var sortCol;									// a tbla ezen oszlop szerint van rendezve
var ndash = unescape("%u2013");	// ez van &ndash; helyett a cellkban

function sortTable(column) {
	// megkeressk a tblt, amin dolgoznunk kell
	var table = document.getElementById("sortable");

	// ha csak egy sora van, akkor nem foglalkozunk vele
	if (table.rows.length <= 1) return;						

	var actHead = table.tHead.rows[0].cells[Math.abs(sortCol) - 1];
	if (actHead) {
		actHead.className = actHead.className.replace((sortCol > 0) ? "asc" : "des", "");
	}

	// ha a jelenlegivel azonos oszlopra kattintott, akkor megfordtjuk a rendezst
	sortCol = column * ((column == sortCol) ? -1 : 1);
	
	for (var b = 0; b < table.tBodies.length; b++) {
		// csak az egy sornl hosszabb tblatestekkel foglalkozunk
		if (table.tBodies[b].rows.length > 1) {
			// kell egy tmb, amibe kigyjtjk a teljes tblatestet
			var newRows = new Array();
			
			// a tmbbe betltjk az sszes cella tartalmt s stlust
			for (var r = 0; r < table.tBodies[b].rows.length; r++) {
				newRows[r] = new Array();
				for (var c = 0; c < table.tBodies[b].rows[r].cells.length; c++) {
					newRows[r][c] = new Object();
					newRows[r][c].value = table.tBodies[b].rows[r].cells[c].innerHTML;
					newRows[r][c].style = table.tBodies[b].rows[r].cells[c].className;
				}
			}

			// a tmbt lerendezzk a sortFn fggvny segtsgvel
			newRows.sort(sortFn);
		
			// a tmb tartalmt visszarjuk a tblatestbe
			for (var r = 0; r < table.tBodies[b].rows.length; r++) {
				for (var c = 0; c < table.tBodies[b].rows[r].cells.length; c++) {
					table.tBodies[b].rows[r].cells[c].innerHTML = newRows[r][c].value;
					table.tBodies[b].rows[r].cells[c].className = newRows[r][c].style;
				}
			}
		}
		
		var newHead = table.tHead.rows[0].cells[Math.abs(sortCol) - 1];
		newHead.className += (sortCol > 0) ? " asc" : " des";
		newHead.firstChild.blur();
	}
}

function sortFn(a, b) {
	if (Math.abs(sortCol) == 1) {
		// az els oszlop szveges
		var aa = removeAccents(a[0].value.toLowerCase());
		var bb = removeAccents(b[0].value.toLowerCase());
	} else {
		// a tbbi oszlopban szmok vannak
		var aa = a[Math.abs(sortCol) - 1].value;
		var bb = b[Math.abs(sortCol) - 1].value;
		
		if (aa == ".." || aa == ndash) {
			// a kt pontot s a kihzst vgtelenn alaktjuk
			aa = (sortCol > 0) ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
		} else {
			aa = aa.replace(ndash, "-"); 	// a szm elejn a ktjelbl mnusz lesz
			aa = aa.replace(",", "."); 		// a tizedesvesszbl tizedespont lesz
			aa = aa.replace(" ", "");			// az ezres osztsokat eltntetjk
			aa = parseFloat(aa);				// gy mr szmm alakthat a szveg
		}
		
		if (bb == ".." || bb == ndash) {
			// a kt pontot s a kihzst vgtelenn alaktjuk
			bb = (sortCol > 0) ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
		} else {
			bb = bb.replace(ndash, "-"); 	// a szm elejn a ktjelbl mnusz lesz
			bb = bb.replace(",", "."); 		// a tizedesvesszbl tizedespont lesz 
			bb = bb.replace(" ", "");			// az ezres osztsokat eltntetjk 
			bb = parseFloat(bb);				// gy mr szmm alakthat a szveg
		}
	}
		
	// ha egyik sem rtk, akkor a rendezs alapja az els oszlop
	if ((aa == Number.POSITIVE_INFINITY || aa == Number.NEGATIVE_INFINITY) && 
	    (bb == Number.POSITIVE_INFINITY || bb == Number.NEGATIVE_INFINITY)) {
		ac = removeAccents(a[0].value.toLowerCase());
		bc = removeAccents(b[0].value.toLowerCase());
		if (ac = bc)
			return 0;
		else
			return (ac < bc) ? -1 : 1;
	}
	
	if (aa == bb)
		return 0;
	else
		return ((aa < bb) ? -1 : 1) * ((sortCol < 0) ? -1: 1);
}

function removeAccents(str) {
	// a rendezskor az kezetes betk zavarak, ezrt eltntetjk az kezeteket
	str = str.replace(//g, "a"); str = str.replace(//g, "e"); str = str.replace(//g, "i");
	str = str.replace(//g, "o"); str = str.replace(//g, "o"); str = str.replace(//g, "o");
	str = str.replace(//g, "u"); str = str.replace(//g, "u"); str = str.replace(//g, "u");
	
	str = str.replace(//g, "A"); str = str.replace(//g, "E"); str = str.replace(//g, "I");
	str = str.replace(//g, "O"); str = str.replace(//g, "O"); str = str.replace(//g, "O");
	str = str.replace(//g, "U"); str = str.replace(//g, "U"); str = str.replace(//g, "U");

	return str;
}

function initPage() {
	// vgignzzk az sszes tblt 
	var tables = document.getElementsByTagName("table");

	for (var t = 0; t < tables.length; t++) {
		if (tables[t].className.indexOf("zebra") > -1) {
			// becskozzuk a tblt
			for (var b = 0; b < tables[t].tBodies.length; b++) {
				for (var r = 0; r < tables[t].tBodies[b].rows.length; r++) {
					// a pros sorok "even", a pratlanaok "odd" stlust kapnak
					tables[t].tBodies[b].rows[r].className += (r % 2 == 0) ? " even" : " odd";
					
					// kivltjuk a tr:hover-t kt egyszer fggvnnyel
					tables[t].tBodies[b].rows[r].onmouseover = function() { this.className += " activerow"; }
					tables[t].tBodies[b].rows[r].onmouseout  = function() { this.className = this.className.replace("activerow", ""); }
					
					// a cellkrl levesszk a felesleges kereteket
					for (var c = 0; c < tables[t].tBodies[b].rows[r].cells.length; c++) {
						tables[t].tBodies[b].rows[r].cells[c].className += " noborder";
					}
				}
			}
		}
					
		if (tables[t].id == "sortable") {
			// a fejlcre linkeket helyeznk a rendezshez
			for (var c = 0; c < tables[t].tHead.rows[0].cells.length; c++) {
				// ltrehozunk egy j linket
				var newLink = document.createElement("a");
				newLink.href = "javascript:sortTable(" + (c + 1) + ")";
		
				// a linkhez hozzadjuk a cella sszes elemt
				var children = tables[t].tHead.rows[0].cells[c].childNodes;
				for (var n = 0; n < children.length; n++) {
					newLink.appendChild(children[n]);
				}
				
				// az j linket hozzadjuk a cellhoz
				tables[t].tHead.rows[0].cells[c].appendChild(newLink);
			}
		}	
	}
}

window.onload = initPage;

